From 7f59a693e4d058ba0abdf3d5f81ab0e215418227 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Jan 02 2021 08:07:41 +0000
Subject: [PATCH 1953/2232] Fix a wrong cast in Slice<T>::iterator::operator[]


    cxx-test-suite-2b81d5f39edd0bcf/out/cxxbridge/include/rust/cxx.h:559:11: error: invalid static_cast from type ‘char*’ to type ‘const unsigned char*’
      559 |   return *static_cast<T *>(pos);
          |           ^~~~~~~~~~~~~~~~~~~~~

Doing a reinterpret_cast<> instead matches what is done a few lines
above by Slice<T>::operator[].

---

diff --git a/include/cxx.h b/include/cxx.h
index 38261b7..7274a5c 100644
--- a/include/cxx.h
+++ b/include/cxx.h
@@ -556,7 +556,7 @@ template <typename T>
 typename Slice<T>::iterator::reference Slice<T>::iterator::operator[](
     typename Slice<T>::iterator::difference_type n) const noexcept {
   auto pos = static_cast<char *>(this->pos) + this->stride * n;
-  return *static_cast<T *>(pos);
+  return *reinterpret_cast<T *>(pos);
 }
 
 template <typename T>

